/*  xa-003 
 *  Copyright (C) Joakim Kolsjö and Anders Asplund 2004
 *	This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
 */ 

#include "../base/xio.h"
#include "../base/xdm.h"
#include "../gfx/gfx_anim.h"
#include "../gfx/gfx_sort.h"

namespace scene
{
	class Greets : public xdm::Scenebase {
	public:
		Greets(xio::Manager *i);
		virtual ~Greets() {};
		int draw(long time, float move);
	private:
		void drawCord(int x1, int y1, int x2, int y2);
		gfx::Anim gfx_anim;	
		xio::surface *bottomsidewalk_warp, *bottomsidewalk;
		xio::surface *topsidewalk_warp, *topsidewalk;
		xio::surface *road, *road_warp;
		xio::surface *dance;
		gfx::Sort gfx_sort;
		bool spart[10][10];
		xio::Random random;
	};
}
